package extensions;

import java.io.IOException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import java.net.URL;
import java.net.Socket;
import java.net.URLDecoder;
import java.net.URLEncoder;

import java.text.SimpleDateFormat;

import java.util.Date;
import java.util.ArrayList;
import java.util.TreeSet;
import java.util.Iterator;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.zip.GZIPInputStream;
import java.util.zip.InflaterInputStream;

import dareka.Main;
import dareka.common.CloseUtil;
import dareka.common.Logger;
import dareka.common.regex.JavaMatcher;
import dareka.common.regex.JavaPattern;
import dareka.extensions.Extension;
import dareka.extensions.Rewriter;
import dareka.extensions.RequestFilter;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.processor.HttpHeader;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.Resource;
import dareka.processor.URLResource;
import dareka.processor.StringResource;
import dareka.processor.Processor;
import dareka.processor.TransferListener;
import dareka.processor.impl.Cache;
import dareka.processor.impl.EasyRewriter;
import dareka.processor.impl.RewriterProcessor;
import dareka.processor.impl.NicoApiUtil;

/*
 *
 */
// public class cacheCommentExtension extends URLResource implements Extension, Extension2, Processor, Rewriter, RequestFilter, TransferListener {
public class cacheCommentExtension implements Extension, Extension2, Processor, Rewriter, RequestFilter {

	// Extension interface
	public Object queryInterface(Extension.Type type) {
		try {
			if (type == Extension.Type.Extension1)
				return (Extension) this;
			if (type == Extension.Type.Processor1)
				return (Processor) new cacheCommentExtension();
			if (type == Extension.Type.RequestFilter1)
				return (RequestFilter) this;
			if (type == Extension.Type.Rewriter1)
				return (Rewriter) this;
			return null;
		} catch (IOException e) {
			Logger.debug(e);
		}
		return null;
	}

	public void registerExtensions(ExtensionManager mgr) {
		try {
			mgr.registerProcessor(new cacheCommentExtension());
			mgr.registerRewriter(this);
			mgr.registerRequestFilter(this);
		} catch (IOException e) {
			Logger.debug(e);
		}
	}

	public String getVersionString() {
		return "cacheCommentExtension (9).06a mod";
	}

/* RXgN^Aݒ (fin) */
/***************************************************************************/
// Ƃ肠 cache/#comment RgLbVpɂĂ݂
    private static File cacheCommentDir = new File("cache/#comment");
	private static boolean alreadyInitCacheComment = false;

/*
 * RXgN^ňxݒ
 */
	public cacheCommentExtension() throws IOException {
//		super("http://dummy.url.com");
		// staticinit
		if (!alreadyInitCacheComment) {
Logger.debug("cc:init start");
			alreadyInitCacheComment = true;
	        // Rgۑ
		   	String autoCacheComment = System.getProperty("autoCacheComment", "false");
			if (autoCacheComment.equals("false"))
				Logger.info(" autoCacheComment off.");
			else if (autoCacheComment.equals("one"))
				Logger.info(" 1-comment auto cache mode.");
			else if (autoCacheComment.equals("all"))
				Logger.info(" all-comments auto cache mode.(Bad...)");
			else if (autoCacheComment.matches("[0-9]+"))
				Logger.info(" new comment auto cache mode. threshold: "+autoCacheComment+"%");
			else {
				Logger.info(" => Invalid autoCacheComment setting. autoCacheComment off...");
	            System.setProperty("autoCacheComment", "false");
			}
			if (System.getProperty("useCommentCacheNum", "true").equals("true")) {
				Logger.info(" use cacheCommentNum on.");
			} else {
				Logger.info(" use cacheCommentNum off.");
			}

			// LbVfBNgݒ
			String cacheDir = System.getProperty("cacheFolder", "");
			if (!cacheDir.equals("")){ 
				cacheCommentDir = new File(cacheDir+"/#comment");
			}
	   	    id2NameMap.clear();
   		    tmp_watchId2Buf.clear();
			id2LastRes.clear();
	        cacheCommentDir.mkdir();
        	searchCacheCommentsOnADirectory(cacheCommentDir, 1);
Logger.debug("cc:init end");
		}
	}

// 2̃RXgN^́AURL_POST_ResourceƂČŒ`



/* ProcessorubN (fin) */
/*****************************************************************************/
	// Processor Interface
    private static final String[] PROCESSOR_SUPPORTED_METHODS =
        new String[] { "GET","POST" };

	public String[] getSupportedMethods() {
	    return PROCESSOR_SUPPORTED_METHODS;
	}

    private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"(^http://msg[0-9]*\\.nicovideo\\.jp/([0-9]+/)?api/$)|"+
			"(^http://www\\.nicovideo\\.jp/comment/.*$)|"+
			"(^http://www\\.nicovideo\\.jp/force/[a-z]{2}[0-9]+(\\?comment_cache=[a-z][0-9]+)?(?:\\?[0-9]+)?$)");

// {̂ɓ
//			"(^http://[^/]+\\.nicovideo\\.jp/api/getflv(?:\\?[vms]=|/)[a-z]{2}[0-9]+(?:\\?.*)?$)");


	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}

	public String getSupportedURLAsString() {
		return null;
	}

// evZbTpPattern
	private static final Pattern MSG_PROCESSOR_PATTERN = Pattern.compile(
			"^http://msg[0-9]*\\.nicovideo\\.jp/([0-9]+/)?api/$");
	private static final Pattern LOCAL_PROCESSOR_PATTERN = Pattern.compile(
			"^http://www\\.nicovideo\\.jp/comment/(.*)$");
	private static final Pattern FORCE_PROCESSOR_PATTERN = Pattern.compile(
			"^http://www\\.nicovideo\\.jp/force/([a-z]{2}[0-9]+)(?:\\?comment_cache=([a-z])([0-9]+))?(?:[?&][0-9]+)?$");
//	private static final Pattern GETFLV_PROCESSOR_PATTERN = Pattern.compile(
//			"^http://[^/]+\\.nicovideo\\.jp/api/getflv(?:\\?[vms]=|/)([a-z]{2})([0-9]+)(?:\\?.*)?$");

/*
 * bZ[WT[oƃ[J̃RgXg擾p
 */
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
			throws IOException {
Logger.debug("cc:processor (URI):"+requestHeader.getURI());
// URIŕ
		Resource resource = null;
// bZ[WT[oւ̃ANZX
		Matcher m = MSG_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
		if (m.matches()) {
			resource = msgProcessorOnRequest(requestHeader, browser);
		}
// [JRgXg̎擾
		m = LOCAL_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
		if (m.matches()) {
			resource = localCommentProcessorOnRequest(requestHeader, browser);
		}
// Đy[W̍쐬
		m = FORCE_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
		if (m.matches()) {
			resource = forceProcessorOnRequest(requestHeader, browser);
		}
// getflv̝s
//		m = GETFLV_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
//		if (m.matches()) {
//			resource = getflvProcessorOnRequest(requestHeader, browser);
//		}

		if (resource == null)
			resource = new StringResource("error");
		return resource;
	}

/* CacheCommentProcessorubN (fin) */
/* ------------------------------------------------------------------------ */
// RgLbVւ̃ANZXpReferer
	private static final Pattern CACHECOMMENT_REFERER = Pattern
			.compile("(^(?:[^,]*,)?http://(?:www\\.nicovideo|res\\.nimg)\\.jp/(?:swf/|local/)?(?:[^/]+/)?(?:nico|flv)player(?:_wrapper)?\\.swf\\?ts=)([a-z]{2}[0-9]+)([a-z])([0-9]+)([^a-z0-9].*)?(?:,.*)?$");

// RgۑpReferer
	private static final Pattern AUTOCACHE_REFERER = Pattern
			.compile("^(?:[^,]*,)?http://(?:www\\.nicovideo|res\\.nimg)\\.jp/(?:swf/(?:[^/]+/)?|local/)?(?:[^/]+/)?(?:nico|flv)player(?:_wrapper)?\\.swf\\?ts=([0-9]+t[a-z0-9]+)(?:[^a-z0-9].*)?(?:,.*)?$");

// RgۑpReferer
	private static final Pattern CLICK_REVISION = Pattern
			.compile("click_revision=\"[1-9]");

// ǂWatchy[W̃ANZẌӂ̎ʎq
	private String watchId = null;

/*
 * bZ[WT[o֌W
 */
	private Resource msgProcessorOnRequest(HttpRequestHeader requestHeader, Socket browser)
		throws IOException {
		String referer = requestHeader.getParameter("nl-from");
		String uri = requestHeader.getURI();
Logger.debug("cc:msg processor (URI):"+uri);
Logger.debug("cc:msg processor (nl-Referer):"+referer);

		RewriterProcessor rewriter = Main.getRewriterProcessor();

// POST̎M
		InputStream in = browser.getInputStream();
		int contentLength = (int)requestHeader.getContentLength();
		byte[] postBuf = new byte[contentLength];
		int pos = 0;

		while (pos < contentLength) {
			int len = contentLength - pos;
			pos += in.read(postBuf, pos, len);
		}
		String postString = new String(postBuf,"UTF-8");
Logger.debug("cc:msg processor (POST):"+postString);

		Matcher mAutoCache = null;
// referernullĂƂ͖͂
// ʃ}VŗĂĂāAm[refererĂƂ
		if (referer == null) {
			referer = requestHeader.getMessageHeader("Referer");
		}
		if (referer != null) {
// ΉRefererȂ΂̂܂
			Matcher mCache = CACHECOMMENT_REFERER.matcher(referer);
			mAutoCache = AUTOCACHE_REFERER.matcher(referer);
//			Matcher clickRevision = CLICK_REVISION.matcher(postString);
// LbṼRg擾
			if (mCache.matches()) {
// bZ[WT[oPOSTȂ悤
				requestHeader.setContentLength(0); 
				requestHeader.setMethod("GET");

//				if (!clickRevision.find()) {
//					return new StringResource("error");
//				}


// e҃Rgǂ
// ɂp^[邩ȂǁAv~AȂ̂Œm
				String flag;
				if (postString.indexOf("fork=") != -1)
					flag = AUTHOR_COMMENT;
				else
					flag = NORMAL_COMMENT;

// Rg[h?
				if (mCache.group(3).equals(NO_COMMENT)) {
					flag = NO_COMMENT;
				}

				String res_from = "1";
				String thread = null;
				Pattern pattern = Pattern.compile("thread=\"([0-9]+)\"");
				Matcher m = pattern.matcher(postString);
				if (m.find()) {
					thread = m.group(1);
				}
				pattern = Pattern.compile("res_from=\"([^\"]+)\"");
				m = pattern.matcher(postString);
				if (m.find()) {
					res_from = m.group(1);
				}
				long date = new Date().getTime() / 1000;

// [J[̎XṼANZX͌ŏ
// R͍ŏɓǂݍ񂾌AXV͂Ȃ݂
				if (true || postString.indexOf("res_from=\"-") != -1 || flag.equals(AUTHOR_COMMENT)) {
					String smid = mCache.group(2);
					String cc_date = mCache.group(4);
					
					// ۂɃt@C擾ꍇɃbZ[W\悤ɕύX
		//			if (postString.indexOf("res_from=\"-") != -1) Logger.info("Using Comment Cache.");

// ̃RgԂ
					if (flag.equals(NO_COMMENT)) {
						String str =
							"<?xml version=\"1.0\" encoding=\"UTF-8\"?><packet>" +
							"<thread last_res=\"0\" resultcode=\"0\" revision=\"1\" server_time=\"" + date;
						if (thread != null) {
							str += "\" thread=\"" + thread;
						}
						str +=
							"\" ticket=\"0x0\"/>" +
							"<view_counter id=\"" + smid + "\" mylist=\"72\" video=\"765\"/>";
// ̓Rǉ
						if (flag.equals(AUTHOR_COMMENT)) {
							str += "<thread fork=\"1\" last_res=\"0\" resultcode=\"0\" revision=\"1\" server_time=\"" + date;
							if (thread != null) {
								str += "\" thread=\"" + thread;
							}
							str += "\" ticket=\"1247525194\"/>";
						}

						str += "</packet>";
						StringResource r = new StringResource(str);
						r.addNoCacheResponseHeaders();
						return r;
					}
// IDAFLAGADATEŖ₢킹
					File file = getCommentFile(smid, NORMAL_COMMENT, cc_date);

/*
					if (file == null && flag.equals(AUTHOR_COMMENT)) {
						flag = NORMAL_COMMENT;
						file = getCommentFile(mCache.group(2), flag, mCache.group(4));
					}
*/
					if (file == null) {
						Logger.info("Cached CommentFile not found.");
						return new StringResource("error");
					}

					String content = readFile(file);
					if (content == null) {
						Logger.info("Cached CommentFile not found.");
						return new StringResource("error");
					}
// RNGXgĂāA܂܂ĂȂΒǉ
					if (flag.equals(AUTHOR_COMMENT)
							&& content.indexOf("fork=") == -1) {
						String authorContent = null;
						File file2 = getCommentFile(smid, AUTHOR_COMMENT, cc_date);
						if (file2 != null) {
							authorContent = readFile(file2);
							pattern = Pattern.compile("(?s)(<thread [^>]*fork=.*</packet>)");
							m = pattern.matcher(authorContent);
							if (m.find()) {
								authorContent = m.group(1);
							} else {
								authorContent = null;
							}
						}
						if (authorContent == null) {
// ΋̓Rǉ
// LbVthread擾
							thread = null;
							pattern = Pattern.compile("thread=\"([0-9]+)\"");
							m = pattern.matcher(content);
							if (m.find()) {
								thread = m.group(1);
							}
							authorContent = "<thread fork=\"1\" last_res=\"0\" resultcode=\"0\" revision=\"1\" server_time=\"" + date;
							if (thread != null) {
								authorContent += "\" thread=\"" + thread;
							}
							authorContent += "\" ticket=\"1247525194\"/></packet>";
						}

						if (content.indexOf("</packet>") != -1) {
							content = content.replaceFirst("</packet>", authorContent);
						} else {
							Logger.info("Unable to parse CommentCache : " + smid);
						}
					}
// threadԍC
/*
					if (thread != null) {
Logger.info("th:"+thread);
						content.replaceAll("thread=\"\\d+\"", "thread=\""+thread+"\"");
					}
*/
// LbVɂRewriterKp
	//				StringResource r = new StringResource(rewriter.stringRewriter(uri, content));
//					HttpResponseHeader responseHeader = null;

					// J悾ƐVvŃ[JRgȂ΍
					// nlFilter1000000000(ˋthreadID:Sun Sep 09 2001 10:46:40eɑ)ǉĂ
					if (postString.contains("thread=\"1000000000\"") && !content.contains("thread=\"1000000000\"")){
						content = content.replaceAll("thread=\"\\d+\"", "thread=\"1000000000\"");
					}

					StringResource r = new StringResource(rewriter.stringRewriter(uri, content, requestHeader, null));
					
					r.addNoCacheResponseHeaders();
					Logger.info("Using Comment Cache. (" + smid + " " + cc_date.replaceFirst("(\\d{2})(\\d{2})(\\d{2})(\\d{2})(\\d{2})(\\d{2})", "$1/$2/$3 $4:$5:$6") + ")");
					return r;
				} else {
// XṼvCs
//						Logger.info("cacheCommentExtension Auto Comment-Reload Block.");
/*
					String last_res = String.valueOf(Integer.decode(res_from)-1);
					String str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+
							"<packet><thread last_res=\""+last_res+"\" "+
							"resultcode=\"0\" revision=\"1\" "+
							"server_time=\""+date+"\"";
					if (thread != null) {
						str += " thread=\""+thread+"\"";
					}
					str += "/></packet>";
*/
					String str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+
							"<packet></packet>";
					StringResource r = new StringResource(str);
					r.addNoCacheResponseHeaders();
					return r;
				}
			}
		}
 

// POST̓euāARg𓊍eA擾
// Rewriter𗘗pď
		String postURI = uri.replaceFirst("^http://", "http://POST/");
//		postString = rewriter.stringRewriter(postURI, postString);
//		HttpResponseHeader responseHeader = null;
		postString = rewriter.stringRewriter(postURI, postString, requestHeader, null);
		postBuf = postString.getBytes("UTF-8");
		requestHeader.setMessageHeader("Content-Length", ""+postBuf.length);
		requestHeader.removeHopByHopHeaders();

//		byte[] bcontent = postServer(requestHeader, postBuf);
		URLResource ur = new URLResource(requestHeader.getURI());
		HttpResponseHeader responseHeader = ur.getResponseHeader(new ByteArrayInputStream(postBuf), requestHeader);
		byte[] bcontent = ur.getResponseBody();

		if (bcontent == null) {
			return new StringResource("error");
		}
		String content = new String(bcontent, "UTF-8");
// XVȂȂۑ
// autoCacheLȂ΁AReferer͗Ȃ
/* [2011/01/03] ύX_ \\d  [1-9] wrapper(res_from="0")Ώۂɂ邽߁B
//(wrapper̎XVΏۂɂȂĂ͂BǁAres_from="0"ȂˁB)
		if ( (!postString.matches(".*res_from=\"\\d.*")
					|| postString.contains("fork="))
					&& mAutoCache != null
					&& mAutoCache.matches()) {
*/
/*
Logger.info("[debug] cc:watchId = "+ watchId + ":" +content.length()+"");
Pattern pattern = Pattern.compile("</chat>");
Matcher m = pattern.matcher(content);
int commentLen = 0;
while (m.find()) {
	commentLen++;
}
Logger.info("[debug] cc:  (" + commentLen + ")");
*/
		if ( postString.contains("<thread") && content.contains("</chat>")
				 && (!postString.matches(".*res_from=\"[1-9].*")
					|| postString.contains("fork="))
					&& mAutoCache != null
					&& mAutoCache.matches()) {
			watchId = mAutoCache.group(1);
			if (!System.getProperty("autoCacheComment", "false").equals("false")){
				storeComment(bcontent, watchId, postString);
			}
		}

// RewriterĂяo
		StringResource r;
		if (postString.contains("postkey=\"")) {
			r = new StringResource(content);
		} else {
//			r = new StringResource(rewriter.stringRewriter(uri, content));
			r = new StringResource(rewriter.stringRewriter(uri, content, requestHeader, responseHeader));
		}
		r.addResponseHeader(HttpHeader.CONTENT_TYPE, "text/xml");
		r.addNoCacheResponseHeaders();
		return r;
	}

	private String readFile(File file) throws IOException {
		BufferedInputStream in = new BufferedInputStream(new FileInputStream(file));
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		int len;
		byte[] buf = new byte[256];
		try {
			while ( (len = in.read(buf, 0, 256)) != -1)
				out.write(buf, 0, len);
		} catch (IOException e) {
			return null;
		} finally {
			CloseUtil.close(in);
			CloseUtil.close(out);
		}
		return new String(out.toByteArray(), "UTF-8");
	}



/* CommentDirProcessorubN (fin) */
/* ------------------------------------------------------------------------ */

/*
 * [JRgXg̎擾AuEŨtH[RgۑȂ
 */
	private Resource localCommentProcessorOnRequest(
				HttpRequestHeader requestHeader, Socket browser)
				throws IOException {
Logger.debug("cc:local processor (URI):"+requestHeader.getURI());
		String path = "";
		Matcher m = LOCAL_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
		if (m.matches()) {
			path = m.group(1);
		}

// comment/cacheCommentList.json?[ID] ł̓̃Rg̃Xg
		if (path.startsWith("cacheCommentList.json?")) {
			String id = path.substring(22);
			String str = getCacheCommentDateAsJson(id);
			if (str == null) {
				return new StringResource("");
			}
			StringResource r = new StringResource(str);
			r.addNoCacheResponseHeaders();
			r.addResponseHeader(HttpHeader.CONTENT_TYPE, "application/x-javascript");
			return r;
		}

// comment/cacheCommentSave?[ID]&[擾Rg]
// IĎ݂̃Rgۑ
// &ȍ~͏ȗ\Aȗ̓jRjR̃ftHg
		else if (path.startsWith("cacheCommentSave?")) {
			String parm = path.substring(17);
			if (saveComment(requestHeader, parm)) {
				StringResource r = new StringResource("OK");
				r.addNoCacheResponseHeaders();
				return r;
			}
			return new StringResource("NG");
		}

// comment/removeCacheComment?[ID](_[DATE])
// Rg폜
		else if (path.startsWith("removeCacheComment?")) {
			String parm = path.substring(19);
			Pattern pattern = Pattern.compile("([a-z]{2}[0-9]+)(?:_([0-9]+))");
			m = pattern.matcher(parm);
			if (m.matches()) {
				removeCommentFile(m.group(1), m.group(2));
			} else {
				removeCommentFile(parm);
			}
			StringResource r = new StringResource("OK");
			r.addNoCacheResponseHeaders();
			return r;
		}

// comment/removeCommentExistMovie
// ̂ȂRg폜
		else if (path.equals("removeCommentExistMovie")) {
			removeCommentExistMovie();
			StringResource r = new StringResource("OK");
			r.addNoCacheResponseHeaders();
			return r;
		}

// comment/removeShortComment?
// ̃Rg̃LbV폜
		else if (path.startsWith("removeShortComment?")) {
			int commentNum = Integer.parseInt(path.substring(19));
			removeShortCommentFile(commentNum);
			StringResource r = new StringResource("OK");
			r.addNoCacheResponseHeaders();
			return r;
		}

// RgLbVǗy[W
		else if (path.equals("")) {
			String content =
// wb_
			"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n" +
			"<html>\n<head>\n" +
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n" +
			"<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n" +
			"<meta http-equiv=\"Content-Style-Type\" content=\"text/css\">\n" +
			"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n" +
			"<meta http-equiv=\"Cache-Control\" content=\"no-store, no-cache, must-revalidate, post-check=0, pre-check=0\">\n" +
			"<meta http-equiv=\"Expires\" content=\"Thu, 01 Dec 1994 16:00:00 GMT\">\n" +
			"<script type=\"text/javascript\" src=\"http://res.nimg.jp/js/lib/prototype.js?1.5.1.1_2\"></script>\n" +

			"<title>RgLbVǗy[W</title>\n" +
			"<base href=\"http://www.nicovideo.jp/\">\n" +
			"</head>\n" +

			"<body>\n" +
// y[Wwb_
			"<div id=\"PAGEHEADER\">\n" +
			"<div align=\"right\">\n" +
			"<table border=\"0\" cellpadding=\"0\" cellspacing=\"4\" style=\"font-size:12px;\">\n" +
 			"<tr><td><a href=\"\">gbvy[W</a> | <a href=\"my\">}Cy[W</a> | "+
			"<a href=\"history\">ŋߌ</a> | <a href=\"newarrival\">Ve</a> | "+
			"<span id=\"nlbar\"><a href=\"/cache/\">LbV</a>"+
			"</td></tr></table>" +
			"</div>\n" +
			"</div>\n" +

//y[W{
			"<div id=\"PAGEBODY\">\n" +
			"<h1>RgLbVǗy[W</h1>\n" +
// ۑRgXg̕\p
// XNvgt@Cǂݍ
			"<script type=\"text/javascript\" charset=\"utf-8\" src=\"" + addTS("/local/cacheComment.js") + "\"></script>\n"+
// RgǗptH[
			"<form action=\"#\">\n"+
			"<input id=\"removeCommentExistMovieButton\" type=\"button\" style=\"padding-left:0;\"value=\"LbV̂ȂRgLbV̍폜\" onclick=\"removeCommentExistMovie()\" class=\"submit\">\n"+
			"</form><p>\n"+

			"<form action=\"#\">\n"+
			"<input id=\"removeShortCommentLimit\" type=\"text\" name=\"limit\" size=\"5\" value=\"50\">\n"+
			"<input id=\"removeShortCommentButton\" type=\"button\" value=\"w萔̃Rg̃LbV폜\" onclick=\"removeShortComment()\" class=\"submit\">\n"+
			"</form><br>\n"+
			"100ȏɂ1̓̃Rgׂď̂Œ\n"+

			"</div>\n" +
			"</body></html>\n";

			StringResource r = new StringResource(content);
			r.addNoCacheResponseHeaders();
			return r;
		}

		return null;
	}

/* ForceProcessorubN (fin) */
/* ------------------------------------------------------------------------ */

/*
 * Đp̃y[W쐬
 */

// Đy[Wp̃vC[o[WƂ
	private static String playerVersion = null;
	private static final String PLAYER_VER_DEFAULT = "1286521293";
//	private static String playerVersionXml = null;
//	private static String marqueeVersion = null;


	private Resource forceProcessorOnRequest(
				HttpRequestHeader requestHeader, Socket browser)
				throws IOException {
Logger.debug("cc:force processor (URI):"+requestHeader.getURI());
		String smid, commentId, flag, tsFlag;
		Matcher m = FORCE_PROCESSOR_PATTERN.matcher(requestHeader.getURI());
		if (m.matches()) {
			smid = m.group(1);
			flag = m.group(2);
			commentId = m.group(3);
		} else {
			return new StringResource("error");
		}
		
		/*	----2010/10/12ύX_-------
		String threadId = smid;
		if (smid.substring(0,2).equals("so")) {
			if (m.matches()){
				File file = getCommentFile(smid, flag, commentId);
				if (file != null) {
					String tmp_Comment = readFile(file);
					m = Pattern.compile("thread=\"([0-9]+)\"").matcher(tmp_Comment);
					if (m.find()) {
						threadId = m.group(1);
					}
				}
			} else {
				
			}
		}
		//	----2010/10/12ύX_---܂----/*/
		
// p[^΃Rg͎ɍsĂ݂
		if (flag == null) {
			if (smid.indexOf("so") == 0) {
				flag = "a";
				commentId = "0";
				tsFlag = smid + flag + commentId;
			} else {
				tsFlag = getWatchIdComment() + smid;
				flag = "0";
				commentId = "-1";
			}
		} else {
			tsFlag = smid + flag + commentId;
		}
		
		String ver;
		if (playerVersion == null) {
			Logger.info("playerVersion is not set.Use Default.");
			ver = PLAYER_VER_DEFAULT;
		} else {
			ver = playerVersion;
		}

		Cache cache = new Cache(smid);
		if (!cache.exists()) {
			return new StringResource("error");
		}
		String title = cache.getTitle();
		String extension = cache.getPostfix();
		
		String swfStr = System.getProperty("forcePagePlayerURL", "http://res.nimg.jp/swf/player/nicoplayer.swf");

		String content;
		content =
// wb_
			"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n" +
			"<html>\n<head>\n" +
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n" +
			"<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n" +
			"<meta http-equiv=\"Content-Style-Type\" content=\"text/css\">\n" +
			"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n" +
			"<meta http-equiv=\"Cache-Control\" content=\"no-store, no-cache, must-revalidate, post-check=0, pre-check=0\">\n" +
			"<meta http-equiv=\"Expires\" content=\"Thu, 01 Dec 1994 16:00:00 GMT\">\n" +
			"<title>" + title +"</title>\n" +
			"<base href=\"http://www.nicovideo.jp/\">\n" +
			addTS2(System.getProperty("forcePageHeader1", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader2", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader3", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader4", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader5", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader6", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader7", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader8", "")) + "\n" +
			addTS2(System.getProperty("forcePageHeader9", "")) + "\n" +
			"</head>\n" +

			"<body>\n" +
// y[Wwb_
			"<div id=\"PAGEHEADER\">\n" +
			"<div align=\"right\">\n" +
			"<table border=\"0\" cellpadding=\"0\" cellspacing=\"4\" style=\"font-size:12px;\">\n" +
 			"<tr><td><a href=\"\">gbvy[W</a> | <a href=\"my\">}Cy[W</a> | <a href=\"history\">ŋߌ</a> | " +
			"<span id=\"nlbar\"><a href=\"/cache/\">LbV</a> (<a href=\"/cache/" +
			smid + "/movie\">ۑ</a>E" +
			"<a href=\"/cache/" + smid + "/audio\"></a>E" +
 			"<a href=\"/cache/rm?" + smid +"\">폜</a>)</span> | <a href=\"https://secure.nicovideo.jp/secure/logout\">OAEg</a>"+
			"</td></tr></table>" +
			"</div>\n" +
			"</div>\n" +

//y[W{
			"<div id=\"PAGEBODY\">\n" +
			"<div id=\"WATCHHEADER\">\n" +
			"<h1>" + title + "</h1>\n" +
			"<table border=\"0\" cellspacing=\"4\" cellpadding=\"0\" summary=\"Rg\"><tr>\n" +
			"<td style=\"color:orange\">";
		if (flag.equals("0")) {
			content += "ŐVRg擾Đ";
		} else if (flag.equals(NO_COMMENT)) {
			content += "Rg\ōĐ";
			commentId = "0";
		} else {
			content += " 20" +
			commentId.substring(0,2)+"N"+
			commentId.substring(2,4)+""+
			commentId.substring(4,6)+" "+
			commentId.substring(6,8)+""+
			commentId.substring(8,10)+""+
			commentId.substring(10)+"b _̃[J[";
		}
		content += "</td>\n" +
// 폜{^
			"<td><form action=\"#\">\n"+
			"<input id=\"removeCacheCommentButton\" type=\"button\" value=\"R폜\" onclick=\"removeCacheComment()\" class=\"submit\">\n"+
			"<input id=\"removeAllCacheCommentButton\" type=\"button\" value=\"̓̑SR폜\" onclick=\"removeAllCacheComment()\" class=\"submit\">\n"+
			"</form></td>\n"+

// ۑRgXg̕\p
			"<td id=\"cacheCommentDropList\"></td>\n" +
// RgǗp
			"<td><a href=\"http://www.nicovideo.jp/comment/\">RǗ</a></td>\n"+
			"</tr></table>\n" +
// XNvgt@Cǂݍ
			"<script type=\"text/javascript\" charset=\"utf-8\" src=\"" + addTS("/local/cacheComment.js") + "\"></script>\n"+
// RgLbVXgǂݍݗpID&ǂݍ݃X^[g
			"<script type=\"text/javascript\">\n"+
			"cacheCommentId=\"" + smid + "\";\n"+
			"cacheCommentPrefix=\"" + smid + "\";\n"+
				// cacheCommentDateNumber^ɁB
			"cacheCommentDate="+ commentId + ";\n"+
			"startCacheComment(\"force\");\n"+
			"</script>\n"+
			"</div>\n" +

// vC[
			"<div id=\"flvplayer_container\" style=\"width:984px; height:540px; padding:4px; clear:both; overflow:hidden;\">\n" +
			"<h3 style=\"color:#F30; text-align:center;\">\n" +
			"<script type=\"text/javascript\"><!--\n" +
			"document.write('ŐV <a href=\"http://www.adobe.com/go/getflashplayer\" style=\"color:#F30;\">Adobe Flash Player</a> ɃAbvf[gĂ');\n" +
			"--></script>\n" +
			"<noscript>JavaScript ɂȂĂ邽߃vC[\ł܂</noscript>\n" +
			"</h3></div>\n" +
			"<script type=\"text/javascript\"><!--\n" +
// Đpts̐ݒ
			"var so = new SWFObject(\"" + swfStr +
			"?ts=" + tsFlag + "\", \"flvplayer\", \"984px\", \"540px\", 10, \"#FFFFFF\");\n" +
/*
			"	so.addVariable(\"v\",  \"" + smid + "\");\n" +
			"	so.addVariable(\"videoId\",  \"" + smid + "\");\n" +
			"	so.addVariable(\"deleted\", \"0\");\n" +
			"	so.addVariable(\"thumbTitle\", \"" + URLEncoder.encode(title,"utf-8") + "\");\n" +
			"	so.addVariable(\"thumbDescription\", \" \");\n" +
	
//			"	so.addVariable(\"mylist_counter\", \"0\");\n" +
			"	so.addVariable(\"movie_type\", \"" + extension.replace(".", "") +"\");\n" +
			"	so.addVariable(\"thumbImage\", \"http://tn-skr1.smilevideo.jp/smile?i=" + smid.substring(2) + "\");\n" +
//			"	so.addVariable(\"userSex\", \"0\");\n" +
//			"	so.addVariable(\"userAge\", \"20\");\n" +
//			"	so.addVariable(\"us\", \"0\");\n" +
//			"	so.addVariable(\"wv_id\", \"" + smid + "\");\n" +
//			"	so.addVariable(\"wv_title\", \"test\");\n" +
//			"	so.addVariable(\"wv_code\", \"464b375c\");\n" +
//			"	so.addVariable(\"wv_time\", \"1224240789\");\n" +
			"	so.addVariable(\"player_version_xml\", \"" + ver + "\");\n" +
			"	so.addVariable(\"button_threshold\", \"0\");\n";
*/
//			"	so.addVariable(\"community_id\", \"502629\");\n" +
//			"	so.addVariable(\"community_global_id\", \"ch640\");\n" +
			"	so.addVariable(\"button_threshold\", \"0\");\n" +
			"	so.addVariable(\"thumbTitle\", \"" + URLEncoder.encode(title,"utf-8") + "\");\n" +
			"	so.addVariable(\"thumbDescription\", \" \");\n" +
			"	so.addVariable(\"videoTitle\", \" \");\n" +
			"	so.addVariable(\"threadPublic\", \"1\");\n" +
//			"	so.addVariable(\"is_channel\", \"1\");\n" +
			"	so.addVariable(\"player_version_xml\", \"" + ver + "\");\n" +
			"	so.addVariable(\"player_info_xml\", \"1291871766\");\n" +
			"	so.addVariable(\"marqueeVersion\", \"1294802479\");\n" +
//			"	so.addVariable(\"userPrefecture\", \"48\");\n" +
//			"	so.addVariable(\"csrfToken\", \"1-1295675288-3d26f4925e21df572ef8f78e8a94373bc3a7c894\");\n" +
			"	so.addVariable(\"v\", \"" + smid + "\");\n" +
			"	so.addVariable(\"videoId\", \"" + smid + "\");\n" +
			"	so.addVariable(\"deleted\", \"0\");\n" +
//			"	so.addVariable(\"mylist_counter\", \"0\");\n" +
//			"	so.addVariable(\"mylistcomment_counter\", \"0\");\n" +
			"	so.addVariable(\"movie_type\", \"" + extension.replace(".", "") +"\");\n" +
			"	so.addVariable(\"thumbImage\", \"http%3A%2F%2Ftn-skr1.smilevideo.jp%2Fsmile%3Fi%3D" + smid.substring(2) + "\");\n" +
//			"	so.addVariable(\"videoUserId\", \"0\");\n" +
//			"	so.addVariable(\"userSex\", \"0\");\n" +
//			"	so.addVariable(\"userAge\", \"1\");\n" +
//			"	so.addVariable(\"us\", \"0\");\n" +
//			"	so.addVariable(\"ad\", \"web_pc_player_marquee\");\n" +
//			"	so.addVariable(\"iee\", \"1\");\n" +
//			"	so.addVariable(\"is_community_video\", \"1\");\n" +
//			"	so.addVariable(\"is_community_thread\", \"1\");\n" +
//			"	so.addVariable(\"channelId\", \"ch640\");\n" +
//			"	so.addVariable(\"channelTopURL\", \"http%3A%2F%2Fch.nicovideo.jp%2Fchannel%2Fch640%3Fplayer_icon\");\n" +
//			"	so.addVariable(\"channelVideoURL\", \"http%3A%2F%2Fch.nicovideo.jp%2Fvideo%2Fch640%3Fplayer_icon\");\n" +
//			"	so.addVariable(\"channelName\", \" \");\n" +
//			"	so.addVariable(\"communityPostURL\", \"http%3A%2F%2Fcom.nicovideo.jp%2Fpost%2Fsm13350648%3Fplayer_icon\");\n" +
			"	so.addVariable(\"dicArticleURL\", \"http%3A%2F%2Fdic.nicovideo.jp%2Fv%2F" + smid + "\");\n" +
			"	so.addVariable(\"blogEmbedURL\", \"%2Fembed%2F" + smid + "%3Fplayer_icon\");\n" +
			"	so.addVariable(\"uadAdvertiseURL\", \"http%3A%2F%2Fuad.nicovideo.jp%2Fads%2F%3Fvid%3D" + smid + "%26player_icon1\");\n" +
//			"	so.addVariable(\"useChecklistCache\", \"1\");\n" +
			"	so.addVariable(\"noBanner\", \"1\");\n" +
//			"	so.addVariable(\"category\", \"%E8%B8%8A%E3%81%A3%E3%81%A6%E3%81%BF%E3%81%9F\");\n" +
//			"	so.addVariable(\"categoryGroupKey\", \"g_try\");\n" +
//			"	so.addVariable(\"categoryGroup\", \"%E3%82%84%E3%81%A3%E3%81%A6%E3%81%BF%E3%81%9F\");\n" +
			"	so.addVariable(\"isWide\", \"1\");\n" +
			"	so.addVariable(\"wv_id\", \"" + smid + "\");\n" +
			"	so.addVariable(\"wv_title\", \"" + URLEncoder.encode(title,"utf-8") + "\");\n" +
//			"	so.addVariable(\"wv_code\", \"c7f61d1f\");\n" +
//			"	so.addVariable(\"wv_time\", \"1295588888\");\n" +
//			"	so.addVariable(\"leaf_switch\", \"0\");\n" + 
//			"	so.addVariable(\"isOfficialAnime\", \"1\");\n" +
			"";
// }C[[hɂ邩ǂ
		if (!flag.equals("0")) {
			content += "	so.addVariable(\"mm\", \"1\");\n";
		}

// e҃Rg邩ǂ
/*
		if (flag.equals(AUTHOR_COMMENT)) {
			content += "	so.addVariable(\"has_owner_thread\", \"1\");\n";
		}
*/
		content +=
			"	so.addParam(\"allowScriptAccess\", \"always\");\n" +
			"	so.addParam(\"allowFullScreen\", \"true\");\n" +
			"	so.write(\"flvplayer_container\");\n" +
			"--></script>\n" +
			"<div id=\"WATCHFOOTER\"></div>\n" +
			"</div>\n" +
			"<div id=\"PAGEFOOTER\"><br><br><br><br><br></div>\n" +
			"</body></html>\n";



		StringResource r = new StringResource(content);
		r.addNoCacheResponseHeaders();
		return r;
	}


/* ReWriterubN (fin) */
/****************************************************************************/
	// Rewriter interface
    private static final Pattern WATCH_PAGE_PATTERN
    	= Pattern.compile("^http://www\\.nicovideo\\.jp/watch/([a-z]{2}[0-9]+|\\d+)(\\?.*)?$");
	
	public Pattern getRewriterSupportedURLAsPattern() {
		return WATCH_PAGE_PATTERN;
	}

	// ID擾p
    private static final Pattern VIDEO_ID_PATTERN
    	= Pattern.compile("\"videoId\", \"([a-z]{2}\\d+)\"");

/*
 * watchy[WpRewriter
 */
	public String onMatch(Matcher match, HttpResponseHeader responseHeader, String content)
			throws IOException {
		JavaPattern[] p = EasyRewriter.getMatch("cacheCommentConf");
		String[] r = EasyRewriter.getReplace("cacheCommentConf");

		String smid = match.group(1);
		// [nl] }C̏ꍇ͓eIDĂ (#026)
		if (smid.matches("\\d+")) {
			Matcher m = VIDEO_ID_PATTERN.matcher(content);
			if (m.find()) {
				smid = m.group(1);
			}
// }CłȂ΁A폜EJ`FbN
		} else {
			JavaMatcher jm;
			if (p != null) {
				jm = p[0].matcher(content); 
			} else {
				jm = JavaPattern.compile("(?s)" +
					"<p class=\"[^\"]*\">(͔̓\ɐݒ肳Ă܂B| <strong>[^<]*</strong> ͍Đł܂B݃ANZXłȂA폜ꂽ\܂B).*?</div>|<span id=\"deleted_message_default\">[^<]*</span>.*?</div>"
					).matcher(content);
			}
			
			if (jm.find() && content.indexOf("id=\"flvplayer_container\"") == -1) {
				Cache cache = new Cache(smid);
				if (cache.exists()) {
					content = jm.replaceFirst(
							"$0"+
							"<div><p><h1 style=\"color:red\">Đ</h1><span id=\"cacheCommentDropList\"></span></p>\n"+
// XNvgǂݍ&RgLbVXgǂݍ
							"<script type=\"text/javascript\" charset=\"utf-8\" src=\"" + addTS("/local/cacheComment.js") + "\"></script>\n"+
							"<script type=\"text/javascript\">\n"+
							"cacheCommentId=\""+ smid +	"\";\n"+
							"cacheCommentPrefix=\"" + smid +"\";\n"+
							"startCacheComment(\"force\");\n"+
							"</script>\n"
						);
					return content;
				}
			}
		}

// `lƃ}C݂ȃAhXȂ̂Ńy[We画
		String pageId = match.group(1);
		String cacheCommentPrefix = match.group(1);
		if (content.indexOf("(\"mm\", \"1\")") == -1) {
			pageId = smid;
		} else {
			cacheCommentPrefix = smid;
		}

// url΂A΍urlg
		String url = responseHeader.getParameter("nl-to");
		if (url == null) {
			url = match.group(0);
		}

		Pattern pattern = Pattern.compile("http://www\\.nicovideo\\.jp/watch/([a-z]{2}[0-9]+|\\d+)(?:\\?.+)?\\?comment_cache=([a-z])([0-9]+)(?:[\\?&].+)?");
		boolean useCache = true;
		Matcher urlMatch;
		String flag = "";
		String date = "";

		urlMatch = pattern.matcher(url);
		if (!urlMatch.matches()) {
			useCache = false;
			pattern = Pattern.compile("http://www\\.nicovideo\\.jp/watch/([a-z]{2}[0-9]+|\\d+)(?:\\?.+)?");
			urlMatch = pattern.matcher(url);
			if (!urlMatch.matches()) {
				Logger.warning("cacheComment:watch-pattern error.");
				return content;
			}
		} else {
			flag = urlMatch.group(2);
			date = urlMatch.group(3);
		}

// vC[̃o[W擾
		pattern = Pattern.compile("\"player_version_xml\"\\s*,\\s*\"(\\d+)\"");
		Matcher m = pattern.matcher(content);
		if (m.find()) {
			playerVersion = m.group(1);
		}

// Kv΁Aplayerts=ȉ̕ύX
		pattern = Pattern.compile("(new SWFObject\\(\"(?:http://(?:www\\.nicovideo|res\\.nimg)\\.jp/)?(?:swf/|local/)?(?:[^/]+/)?(?:nico|flv)player(?:_wrapper)?\\.swf\\?ts=)([0-9]+)\"");
		m = pattern.matcher(content);
		if (m.find()) {
// Ots̒lۑ
			tsParameter = m.group(2);
			if (useCache) {

// [J[Đy[W̏--------------------
// ts= ID+flag+dateݒ肷
// ۑt@CID+date+flag̏(\[g邽)ǁA
// łIDdatẽZp[^ƂflagĂ̂ł̏
				content = m.replaceFirst("$1"+smid+flag+date+"\"");

// }C[[hɂ
				content = content.replaceFirst(
					"so\\.addVariable\\(\"v\"",
					"so.addVariable(\"mm\", \"1\");\n\t$0");
				content = content.replaceFirst(
					"(isMymemory:\\s+)false,",
					"$1true,");

// p[^̃tOAe҃Rg邩flvplayer̃[hς
/*
				pattern = Pattern.compile("so\\.addVariable\\(\"has_owner_thread\", \"1\"\\);");
				m = pattern.matcher(content);
				if (m.find()
						&& urlMatch.group(2).equals(NORMAL_COMMENT)) {
					content = m.replaceFirst("");
				} else if (!m.find()
						&& urlMatch.group(2).equals(AUTHOR_COMMENT)) {
					pattern = Pattern.compile("so\\.addVariable\\(\"v\"");
					m = pattern.matcher(content);
					if (m.find()) {
						content = m.replaceFirst("so.addVariable(\"has_owner_thread\", \"1\");$0");
					}
				}
*/

// up^[ǂݍ
				JavaMatcher jm;
				String repString;
				if (p != null) {
					jm = p[2].matcher(content);
					repString = r[2];
				} else {
					jm = JavaPattern.compile(
						"(?s)<td><form action=\"/mymemory_register\".*?</td>\\s*<td>.*?value=\"RgҏW\".*?</td>"
						).matcher(content);
					repString = "<td><ccMenu></td>";
				}

				if (jm.find()) {
// tƂ{^Ƃ
					String repStr = repString.replaceFirst("<ccMenu>",
						"<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" +
/*						"<tr><td><span class=\"font12\" style=\"color:orange\"> 20"+
						urlMatch.group(3).substring(0,2)+"N"+
						urlMatch.group(3).substring(2,4)+""+
						urlMatch.group(3).substring(4,6)+" "+
						urlMatch.group(3).substring(6,8)+""+
						urlMatch.group(3).substring(8,10)+""+
						urlMatch.group(3).substring(10)+"b _̃[J[</span></td>"+
*/				
						"<tr><td><span class=\"font12\" style=\"color:orange\"> "+
						date.substring(0,2)+"/"+
						date.substring(2,4)+"/"+
						date.substring(4,6)+" "+
						date.substring(6,8)+":"+
						date.substring(8,10)+"&nbsp;</span></td>"+
// 폜{^
						"<td><form action=\"#\">"+
						"<input id=\"removeCacheCommentButton\" type=\"button\" value=\"R폜\" title=\"Đ̃Rg1폜\" onclick=\"removeCacheComment()\" class=\"submit\">"+
						"<input id=\"removeAllCacheCommentButton\" type=\"button\" value=\"S폜\" title=\"̓̑SRg폜\" onclick=\"removeAllCacheComment()\" class=\"submit\">"+
						"</form></td>"+
// ۑRgXg̕\p
						"<td id=\"cacheCommentDropList\"></td>" +
// RgǗp
						"<td><a href=\"http://www.nicovideo.jp/comment/\"></a></td>"+
						"</tr></table>"+
// XNvgt@Cǂݍ
						"<script type=\"text/javascript\" charset=\"utf-8\" src=\"" + addTS("/local/cacheComment.js") + "\"></script>"+
// RgLbVXgǂݍݗpID&ǂݍ݃X^[g
						"<script type=\"text/javascript\">"+
						"cacheCommentId=\""+smid+"\";\n"+
						"cacheCommentPrefix=\"" + cacheCommentPrefix +"\";\n"+
						"cacheCommentDate=" + date + ";\n"+
						"startCacheComment(\"cache\");\n"+
						"</script>\n"
					);

					content = jm.replaceFirst(repStr);
				}

// [J[Đy[W܂---------------------------------
			} else {
// ʏwatchy[Wւ̖ߍ -------------------------------------

// autoCacheCommentpwatchIdߍ
// ӂID𖄂ߍ
				if (!System.getProperty("autoCacheComment", "false").equals("false")) {
					content = m.replaceFirst
						("$1"+getWatchIdComment()+pageId+"\"");
				}

// up^[ǂݍ
				JavaMatcher jm;
				String repString;
				if (p != null) {
					jm = p[1].matcher(content);
					repString = r[1];
				} else {
					jm = JavaPattern.compile(
						"(?s)<td><form action=\"/mymemory_register\".*?</td>\\s*<td>.*?value=\"RgҏW\".*?</td>"
						).matcher(content);
					repString = "$0<td><ccMenu></td>";
				}

// Rgۑ{^Ƃ
				if (jm.find()) {
					String repStr = repString.replaceFirst("<ccMenu>",
						"<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">" +
						"<tr>" +
						"<td>"+
// Rgۑ{^
						"<form action=\"#\">"+
						"<input id=\"saveCacheCommentButton\" type=\"button\" value=\"ۑ(Local)\" onclick=\"saveCacheComment()\" class=\"submit\">"+
						"</form>"+
						"</td>"+

// ۑRgXg̕\p
						"<td id=\"cacheCommentDropList\"></td>"+
// RgǗp
						"<td><a href=\"http://www.nicovideo.jp/comment/\"></a></td>"+
						"</tr></table>\n"+
// XNvgǂݍ&RgLbVXgǂݍ
						"<script type=\"text/javascript\" charset=\"utf-8\" src=\"" + addTS("/local/cacheComment.js") + "\"></script>\n"+
						"<script type=\"text/javascript\">\n"+
						"cacheCommentId=\""+smid+"\";\n"+
						"cacheCommentPrefix=\"" + cacheCommentPrefix +"\";\n"+
						"startCacheComment(\"watch\");\n"+
						"</script>\n"
					);
					content = jm.replaceFirst(repStr);
				}
// ʏwatchy[Wւ̖ߍ ܂ -----------------------------
			}
		}

		return content;
	}

/* RequestFilterubN (fin?) */
/****************************************************************************/
// Ώۂ̃p^[
	private static final Pattern CACHECOMMENT_PATTERN1 = Pattern
			.compile("http://.*(?:nicovideo|niconicommons)\\.jp(?!/force/).*(?:\\?|%3F)comment_cache(?:=|%3D)[a-z][0-9]+(?:[^0-9].*)?");
//			.compile("http://.*(?:\\?|%3F)comment_cache(?:=|%3D)[a-z][0-9]+(?:[^0-9].*)?");

	private static final Pattern CACHECOMMENT_PATTERN2 = Pattern
			.compile("(^(?:[^,]*,)?http://(?:www\\.nicovideo|res\\.nimg)\\.jp/(?:swf/|local/)?(?:[^/]+/)?(?:nico|flv)player(?:_wrapper)?\\.swf\\?ts=)([a-z]{2}[0-9]+[a-z][0-9]+)([^a-z0-9].*)?(?:,.*)?$");

	private static final Pattern FORCEPLAY_PATTERN = Pattern
			.compile("^http://www\\.nicovideo\\.jp/force/([a-z]{2}[0-9]+)(\\?comment_cache=[a-z][0-9]+)?$");

	private static final Pattern AUTOCACHE_PATTERN = Pattern
			.compile("(^(?:[^,]*,)?http://(?:www\\.nicovideo|res\\.nimg)\\.jp/(?:swf/|local/)?(?:[^/]+/)?(?:nico|flv)player(?:_wrapper)?\\.swf\\?ts=)([0-9]+t[a-z0-9]+)([^a-z0-9].*)?(?:,.*)?$");

// OtsۑBꖳftHggp
	private static String tsParameter = null;
	private static final String TS_DEFAULT = "1259739382";

/*
 * RgLbVpɏURLReferer߂āA
 * wb_̓p[NɃXgA
 */
	public int onRequest(HttpRequestHeader requestHeader) 
    			throws IOException {
// Refereȑ
		String referer = requestHeader.getMessageHeader("Referer");
		if (referer != null) {
			String from = null;
// Đy[WReferer
			Matcher m = FORCEPLAY_PATTERN.matcher(referer);
			if (m.matches()) {
				referer = "http://www.nicovideo.jp/watch/"+m.group(1);
				from = m.group(0);
			}
// [J[Referer
			m = CACHECOMMENT_PATTERN1.matcher(referer);
			if (m.matches()) {
				referer = referer.replaceAll("(?:\\?|%3F)comment_cache(?:=|%3D)[a-z][0-9]+", "");
				referer = referer.replaceFirst("([^\\?]+)&", "$1?");
				from = m.group(0);
			}
// [J[flvplayerReferer
			m = CACHECOMMENT_PATTERN2.matcher(referer);
			if (m.matches()) {
				String tail = m.group(3);
				if (tail == null)
					tail ="";
				if (tsParameter == null) {
					Logger.info("ts is not set. Use default.");
					referer = m.group(1)+TS_DEFAULT+tail;
				} else {
					referer = m.group(1)+tsParameter+tail;
				}
				from = m.group(0);
			}
// RgۑpID̂referer
			m = AUTOCACHE_PATTERN.matcher(referer);
			if (m.matches()) {
				String tail = m.group(3);
				if (tail == null)
					tail ="";
				if (tsParameter == null) {
					Logger.info("ts is not set. Use default.");
					referer = m.group(1)+TS_DEFAULT+tail;
				} else {
					referer = m.group(1)+tsParameter+tail;
				}
				from = m.group(0);
			}
// Referer߂
			requestHeader.setMessageHeader("Referer", referer);
			if (from != null)
				requestHeader.setParameter("nl-from", from);
		}
// URȈ
		String uri = requestHeader.getURI();
		if (uri != null) {
			String to = null;
// [J[ւ̃ANZX
			Matcher m = CACHECOMMENT_PATTERN1.matcher(uri);
			if (m.matches()) {
				uri = uri.replaceAll("(?:\\?|%3F)comment_cache(?:=|%3D)[a-z][0-9]+", "");
				uri = uri.replaceFirst("([^\\?]+)&", "$1?");
				to = m.group(0);
// [J[ɃANZX鎞́Areferer}CXg
// ubN}[NȂu
/*
				if (referer != null) {
					referer = "http://www.nicovideo.jp/my";
					requestHeader.setMessageHeader("Referer",referer);
				}
*/
			}
// [J[flvplayerւ̃ANZX
			m = CACHECOMMENT_PATTERN2.matcher(uri);
			if (m.matches()) {
				String tail = m.group(3);
				if (tail == null)
					tail ="";
				if (tsParameter == null) {
					Logger.info("ts is not set. Use default.");
					uri = m.group(1)+TS_DEFAULT+tail;
				} else {
					uri = m.group(1)+tsParameter+tail;
				}
				to = m.group(0);
			}
// ۑIDy[Wflvplayerւ̃ANZX
			m = AUTOCACHE_PATTERN.matcher(uri);
			if (m.matches()) {
				String tail = m.group(3);
				if (tail == null)
					tail ="";
				if (tsParameter == null) {
					Logger.info("ts is not set. Use default.");
					uri = m.group(1)+TS_DEFAULT+tail;
				} else {
					uri = m.group(1)+tsParameter+tail;
				}
				to = m.group(0);
			}
// URI߂
			requestHeader.setURI(uri);
			if (to != null)
				requestHeader.setParameter("nl-to", to);
		}

		return RequestFilter.OK;
	}


/* CacheubN (fin) */
/****************************************************************************/
// RgLbV̖K
// sm[0-9]+(ID)_yymmddhhmmss(M)[a-z](tOp)_於(E).xml

    private static final Pattern CACHE_COMMENT_FILE_PATTERN =
            Pattern.compile("^([a-z]{2}[0-9]+)_([0-9]+)([a-z])(_.*)?\\.xml$");

// RɃftHg̃\[ggĂ邩ANormalzɂĂ
// 蔲oUC
	private static final String NORMAL_COMMENT = "z";
	private static final String AUTHOR_COMMENT = "s";
	private static final String NO_COMMENT = "a";

// RgLbṼXgۑp
    private static ConcurrentHashMap<String, ConcurrentHashMap<String, File>>
		id2NameMap = new ConcurrentHashMap<String, ConcurrentHashMap<String, File>>();

// 擾Rg̍ŏIRgԍ
    private static ConcurrentHashMap<String, Integer> id2LastRes = 
			new ConcurrentHashMap<String, Integer>();

//    private static ConcurrentHashMap<String, File> cacheNameMap;

// ۑ̓R̃LbVp
    private static ConcurrentHashMap<String, byte[]> tmp_watchId2Buf = 
			 new ConcurrentHashMap<String, byte[]>();
// ۑpwatchId
	private static AtomicInteger watchIdSource = new AtomicInteger();

/*
 * Rgt@CMapɃ}bsO
 */
    private void searchCacheCommentsOnADirectory(File dir, int depth) {
    	// [nl] fBNgꗗ
//        dirList.add(getDirName(dir));
        
        File[] cacheFiles = dir.listFiles();
		ArrayList<String> authorList = new ArrayList<String>();
        for (File file : cacheFiles) {
            if (file.isDirectory()) {
                searchCacheCommentsOnADirectory(file, depth + 1);
            } else if (file.isFile()) {
				String filename = file.getName();
        		Matcher m = CACHE_COMMENT_FILE_PATTERN.matcher(filename);
        		if (m.find()) {
					String id = m.group(1);
					String date = m.group(2);
					String flag = m.group(3);
					ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
					if (nameMap == null) {
						nameMap = new ConcurrentHashMap<String, File>();
					}
// ܂ʃRgĂȂe҃Rg̃Xg
	               	if (flag.equals(AUTHOR_COMMENT)) {
						if (nameMap.get(date+NORMAL_COMMENT) == null) {
							authorList.add(date+id);
						}
					}
// Mapɂyymmddhhmmss[a-z]ŕۑ
					nameMap.put(date+flag,file);
                	id2NameMap.put(id, nameMap);
                }
            }
        }
// e҃Rĝ݂̂̂̓G[
		for (String authorName : authorList) {
			ConcurrentHashMap<String, File> nameMap = id2NameMap.get(authorName.substring(12));
			if (nameMap != null) {
				if (nameMap.get(authorName.substring(0,12)+NORMAL_COMMENT) == null) {
					Logger.info("Author-Comment Only.Remove... : "+
							authorName.substring(12)+"_"+
							authorName.substring(0,12));
					removeCommentFile(authorName.substring(12), authorName.substring(0,12), AUTHOR_COMMENT);
				}
			} else {
				Logger.info("cacheComment check error.");
			}
		}
    }


/*
 * w肳ꂽLbVFileԂ
 */
	private File getCommentFile(String id, String flag, String date) {
		File file = null;
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap != null) {
			file = nameMap.get(date+flag);
		}
		return file;
	}

/*
 * RgLbṼXgJSONŕԂ
 */
	private String getCacheCommentDateAsJson(String id) {
		boolean useCommentNum = false;
		if (System.getProperty("useCommentCacheNum", "true").equals("true")) {
			useCommentNum = true;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		String str = "{\"item\":{\"mode\":\""+System.getProperty("autoCacheComment", "false")+"\"";

		int lastRes = getLastResCacheComment(id);
		str += ",\"lastRes\":\""+lastRes+"\"";

		if (nameMap != null && !nameMap.isEmpty()) {
			TreeSet<String> cacheDateTreeSet = new TreeSet<String>(nameMap.keySet());
			str += ",\"member\":[";

			Iterator i = cacheDateTreeSet.iterator();
			while (i.hasNext()) {
				String key = (String)i.next();
				String date = key.substring(0,12);
				String flag = key.substring(12);

				str += "{\"value\":\"?comment_cache="+flag+date+"\",";
				str += "\"text\":\""+
						date.substring(0,2)+"."+date.substring(2,4)+"."+
						date.substring(4,6)+"."+date.substring(6,8)+":"+
						date.substring(8,10)+":"+date.substring(10);
// 擾ς݃Rg
				if (useCommentNum) {
					str += " (" + getCommentNum(id, date) + ")";
				}
				str += "\"},";
// Tree^Ń\[gĂ̂ŁA
// e҃Rg̎ɂ͓DatëʃRg͂
// łɓe҃Rg[hœo^Ă邩΂
				if (flag.equals(AUTHOR_COMMENT) && i.hasNext()) {
					i.next();
				}
			}
// Ō","
			str = str.substring(0,str.length()-1);
			str += "]";
		}
		str += "}}";
		return str;
	}

/*
 * ID,datẽRgLbV擾Ԃ
 */
	private static final int LASTRES_BUF2 = 1024;
	private int getCommentNum(String id, String date) {
// v[ĂȂ΁At@C擾
		int res = 0;
		File file = id2NameMap.get(id).get(date+NORMAL_COMMENT);
		if (file == null) {
			return 0;
		}
		BufferedInputStream in = null;
		byte[] buf = new byte[LASTRES_BUF2];
		String content = "";
		
		//*
// SǂݍŃRg𐳊mɌ [2011/01/03 ύX_]
		try {
			content = readFile(file);
		} catch (IOException e) {
		} finally {
			CloseUtil.close(in);
		}
		Pattern pattern = Pattern.compile("</chat>");
		Matcher m = pattern.matcher(content);
		while (m.find()) {
			res++;
		}
		/*/
// 擪ǂݍ
		try {
			int pos = 0;
			in = new BufferedInputStream(
					new FileInputStream(file));
			while (pos < LASTRES_BUF2) {
				int len = in.read(buf, pos, LASTRES_BUF2 - pos);
				if (len == -1) break;
				pos += len;
			}
			content = new String(buf, 0, pos, "utf-8");
		} catch (IOException e) {
		} finally {
			CloseUtil.close(in);
		}

		Pattern pattern = Pattern.compile(" last_res=\"([0-9]+)\" ");
		Matcher m = pattern.matcher(content);
		if (m.find()) {
			res = Integer.decode(m.group(1));
		}
		pattern = Pattern.compile(" no=\"([0-9]+)\"");
		m = pattern.matcher(content);
		if (m.find()) {
			res += 1 - Integer.decode(m.group(1));
		}
		if (res < 1) {
			res = 0;
		}
		//*/
		return res;
	}


/*
 * RgT[oĂĕۑ
 */
	private Boolean saveComment(
			HttpRequestHeader requestHeader, String parm)
			throws IOException {
// ID"sm****"}C[̐̂ǂ炩
// "&"ȍ~̓Rgǂꂾۑ邩
		Pattern pattern = Pattern.compile("(..[0-9]+)([a-z])(?:&([0-9]+))?");
		Matcher m = pattern.matcher(parm);

		String id;
		String flag;
		String commentLength = null;
		if (m.matches()) {
			id = m.group(1);
			flag = m.group(2);
			commentLength = m.group(3);
		} else {
			pattern = Pattern.compile("([0-9]+)&(..[0-9]+)([a-z])");
			m = pattern.matcher(parm);
			if (m.matches()) {
				id = m.group(2);
				flag = m.group(3);
				commentLength = m.group(1);
			} else {
				return false;
			}
		}
// ID瓮𓾂
/*	----2010/10/12ύX_-------
		ConcurrentHashMap<String, String> getMap = getFlvServer(requestHeader, id);
/*/
		boolean isChannel = false;
		String content_tmp = NicoApiUtil.getFlapiContent("getflv?v=".concat(id), requestHeader, null);
		Map<String, String> getMap = NicoApiUtil.query2map(content_tmp);
		if (getMap.containsKey("error")) return false;
		String extra = "";
		isChannel = getMap.containsKey("needs_key");
		if (isChannel && id.matches("\\d+")) {
			content_tmp = NicoApiUtil.getFlapiContent(
					"getthreadkey?thread=".concat(id), requestHeader, null);
			if (content_tmp != null) {
				Map<String, String> map = NicoApiUtil.query2map(content_tmp);
				String threadKey = map.get("threadkey");
				if (threadKey != null) {
					extra += " threadkey=\"" + threadKey + "\"";
					if (map.containsKey("force_184")) {
						extra += " force_184=\"1\"";
					}
				}
			}
		}
//*/	----2010/10/12ύX_---܂----
		if (getMap == null)
			return false;

/* 疢gp [2011/01/03]
// ̒ɂ킹ăRgݒ肷
		if (commentLength == null) {
			int movieLength = Integer.decode(getMap.get("l"));
			if (movieLength <300) {
				commentLength = "250";
			} else if (movieLength <600) {
				commentLength = "500";
			} else {
				commentLength = "1000";
			}
			
// }C[1000œǂݏo炵
// ԂĂ͓̂掞Ԃɉ
			if (id.matches("^[0-9]+$")) {
				commentLength = "1000";
			}
		}
*/
//Logger.info(getMap.toString());

// bZ[WT[oւ̃ANZXɕKvPOSTpf[^
// ̓m[}bZ[Wp
/* [2011/01/03]ύX_
		String postData =
			"<packet><thread click_revision=\"0\" user_id=\""+getMap.get("user_id")+"\" "+
			"res_from=\"-"+commentLength+"\" version=\"20061206\" "+
			"thread=\""+getMap.get("thread_id")+"\"" + extra + " />";
*/
		
		String postData = "<packet>";
		if (id.matches("^[0-9]+$") && !isChannel) { // }C[
			postData += "<thread scores=\"1\" thread=\""+getMap.get("thread_id")+"\" version=\"20061206\" res_from=\"-1000\" user_id=\""+getMap.get("user_id")+"\"/>";
		} else if (commentLength == null) {
			// 撷ŕϓ 100R / 
			int movieLength = Integer.decode(getMap.get("l"));
			int movieLength_m = (int) Math.ceil(movieLength / 60.0);
			if (movieLength < 60) {
				commentLength = "100";
			} else if (movieLength < 300) {
				commentLength = "250";
			} else if (movieLength < 600) {
				commentLength = "500";
			} else {
				commentLength = "1000";
			}
			postData += "<thread scores=\"1\" thread=\""+getMap.get("thread_id")+"\" version=\"20090904\" user_id=\""+getMap.get("user_id")+"\"" + extra + "/>"+
				"<thread_leaves scores=\"1\" thread=\""+getMap.get("thread_id")+"\" user_id=\""+getMap.get("user_id")+"\"" + extra + ">"+
				"0-" + movieLength_m + ":100," + commentLength + "</thread_leaves>";
		} else {
			// 擾Rw
			postData += "<thread scores=\"1\" click_revision=\"0\" user_id=\""+getMap.get("user_id")+"\" "+
				"res_from=\"-"+commentLength+"\" version=\"20061206\" "+
				"thread=\""+getMap.get("thread_id")+"\"" + extra + " />";
		}


// e҃Rg鎞
		if (flag.equals(AUTHOR_COMMENT)) {
// RpPOST
			postData +=
				"<thread fork=\"1\" user_id=\""+getMap.get("user_id")+"\" "+
				"res_from=\"-1000\" version=\"20061206\" "+
				"thread=\""+getMap.get("thread_id")+"\"" + extra + " />";

		}
		postData += "</packet>";

		String url = getMap.get("ms");

// Rg擾
		byte[] buf = getCommentContent(
				requestHeader, url, postData);
		if (buf == null)
			return false;
		String content = new String(buf, "utf-8");

// getflv̏񂩂Aۑp̃^CX^v擾
		String date = new SimpleDateFormat("yyMMddHHmmss").format(
				new Date(
					Long.decode(getMap.get("time")+"000")));

// XVpŏI擾Rg̕ۑ
// U΂Ă邵A܂܂Ƃ߂
		int lastRes = 0;
		pattern = Pattern.compile(" last_res=\"([0-9]+)\" ");
		m = pattern.matcher(content);
		if (m.find()) {
			lastRes = Integer.decode(m.group(1));
		}

// }C[ȂAxmlŏIRg&ID擾
// ǂ}C[̕ۑĂȂEEE
		if (id.matches("^[0-9]+$")) {
// Ō̃RgŏIRgEEÊ͂
			int lastIndex = content.lastIndexOf(" date=\"");
			if (lastIndex != -1) {
				String subStr = content.substring(lastIndex);
				pattern = Pattern.compile(" date=\"([0-9]+)\"");
				m = pattern.matcher(subStr);
				if (m.find()) {
					date = new SimpleDateFormat("yyMMddHHmmss").format(
							new Date(
								Long.decode(m.group(1)+"000")));
				} else {
					Logger.info("cacheCommentExtension : cannot get Date from xml. Use serverTime...");
				}
			} else {
				Logger.info("cacheCommentExtension : cannot get Date from xml. Use serverTime...");
			}
// ʃRɂIDĂBRɂ͖̂Œ
			pattern = Pattern.compile(" id=\"([a-z]{2}[0-9]+)\"");
			m = pattern.matcher(content);
			if (m.find()) {
				id = m.group(1);
			} else {
				Logger.info("cacheCommentExtension : cannot get ID from xml.");
				return false;
			}
// }C[ȂlastRes0
			if (!isChannel) {
				lastRes = 0;
			}
		}

// obt@t@CɕۑALbVXgɓo^
		if (!saveCommentFile(buf, id, date, NORMAL_COMMENT))
			return false;

/* R͈ꊇ擾ɕύX -----------------------------

// e҃Rg鎞
		if (flag.equals(AUTHOR_COMMENT)) {
// RpPOST
			postData =
				"<thread fork=\"1\" user_id=\""+getMap.get("user_id")+"\" "+
				"res_from=\"-1000\" version=\"20061206\" "+
				"thread=\""+getMap.get("thread_id")+"\" />";

			buf = getCommentContent(
					requestHeader, url, postData);
			if (buf == null) {
// R擾łȂʃR폜
				removeCommentFile(id, date, NORMAL_COMMENT);
				return false;
			}
			if (!saveCommentFile(buf, id, date, AUTHOR_COMMENT)) {
// RۑłȂĂʃR폜
				removeCommentFile(id, date, NORMAL_COMMENT);
				return false;
			}
		}
// -----------------------------------------------------
*/

		if (lastRes != 0)
			setLastResCacheComment(id, lastRes);
		
		// Rg
		pattern = Pattern.compile("</chat>");
		m = pattern.matcher(content);
		int len  = 0;
		while (m.find()) {
			len++;
    	}
		Logger.info("Comment save : "+id + " (" + len + ")");
		return true;
	}

/*
 * /api/getflv 瓮GET
 */
	private ConcurrentHashMap<String, String> getFlvServer(
			HttpRequestHeader requestHeader, String id)
			throws IOException {
// uEUGETŗANZX̃NbL[gāA
// /api/getflv 烁bZ[WT[ȍ𓾂
// ̃wb_f[^(RefererƂ)͌ߑłŝsĂ
// ΂ȂÃANZX̂ƂɕۑĂāA
// ̃ANZXł͕ۑꂽŐV̂̂gāA
// ftHgĝ
		String url = "http://flapi.nicovideo.jp/api/getflv/"+id+"?as3=1";
		URLResource r = new URLResource(url);
// _CNgǐՂ
		r.setFollowRedirects(true);

		HttpRequestHeader header = new HttpRequestHeader(HttpHeader.GET+" "+url+" HTTP/1.0\r\n\r\n");
		header.setMessageHeader("Accept", "*/*");
		header.setMessageHeader("Referer", "http://res.nimg.jp/swf/player/nicoplayer.swf?ts=1259739382");
		header.setMessageHeader("x-flash-version", "9,0,124,0");
		header.setMessageHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 1.1.4322)");
		header.setMessageHeader("Connection", "Keep-Alive");
		header.setMessageHeader("Cookie", requestHeader.getMessageHeader("Cookie"));

// ǂݍ&wb_Ɩ{̃p[X
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		r.transferTo(null, bout, header, null);

		ByteArrayInputStream bin = new ByteArrayInputStream(bout.toByteArray());
		HttpResponseHeader responseHeader = new HttpResponseHeader(bin);
		byte[] bcontent = new byte[bin.available()];
		bin.read(bcontent, 0, bin.available());

		if (responseHeader.getStatusCode() != 200) {
			return null;
		}

		String str = new String(bcontent, "ISO-8859-1");
// Mf[^}bsO
		ConcurrentHashMap<String, String> getMap = new ConcurrentHashMap<String, String>();

		Pattern pattern = Pattern.compile("^([^&=]+)=([^&=]+)(?:&(.*))?$");
		while (str != null) {
			Matcher m = pattern.matcher(str);
			if (m.matches()) {
				getMap.put(URLDecoder.decode(m.group(1), "utf-8"),
						URLDecoder.decode(m.group(2), "utf-8"));
				str = m.group(3);
			} else {
				Logger.info("comment Pharse error.");
				return null;
			}
		}
		return getMap;
	}

/*
 * Rg̎擾
 */
	private byte[] getCommentContent(
			HttpRequestHeader requestHeader, String url, String postData)
			throws IOException {


		byte[] postBin = postData.getBytes("ISO-8859-1");
		HttpRequestHeader header = new HttpRequestHeader(HttpHeader.POST+" "+url+" HTTP/1.1\r\n\r\n");

		header.setMessageHeader("Accept", "*/*");
		header.setMessageHeader("Accept-Encoding", "gzip");
		header.setMessageHeader("Referer", "http://res.nimg.jp/swf/player/nicoplayer.swf?ts=1259739382");
		header.setMessageHeader("x-flash-version", "9,0,124,0");
		header.setMessageHeader("Content-Type", "application/x-www-form-urlencoded");
		header.setMessageHeader("Content-Length", ""+postBin.length);
		header.setMessageHeader("User-Agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 1.1.4322)");
		header.setMessageHeader("Connection", "Keep-Alive");
		header.setMessageHeader("Pragma", "no-cache");
		header.setMessageHeader("Cookie", requestHeader.getMessageHeader("Cookie"));

		return postServer(header, postBin);
	}

/*
 * T[o[ւPOST
 */

	private byte[] postServer(
			HttpRequestHeader requestHeader, byte[] postBin)
			throws IOException {
// 𓀂łȂEncoding͍폜
		String acceptEncoding = requestHeader.getMessageHeader("Accept-Encoding");
		if (acceptEncoding != null) {
			acceptEncoding = acceptEncoding.toLowerCase().replaceAll("( *,)?(bzip2|sdch)", "");
			acceptEncoding = acceptEncoding.replaceFirst("^ *," ,"");
			requestHeader.setMessageHeader("Accept-Encoding", acceptEncoding);
		}

		URLResource r = new URLResource(requestHeader.getURI());
		ByteArrayInputStream bin = new ByteArrayInputStream(postBin);
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		r.transferTo(bin, bout, requestHeader, null);

		bin = new ByteArrayInputStream(bout.toByteArray());
		HttpResponseHeader responseHeader = new HttpResponseHeader(bin);
		byte[] bcontent = new byte[bin.available()];
		bin.read(bcontent, 0, bin.available());

		if (responseHeader.getStatusCode() != 200) {
			return null;
		}

// kĂ
		String contentEncoding = responseHeader.getMessageHeader("Content-Encoding");
		if (contentEncoding != null) {
			contentEncoding = contentEncoding.toLowerCase();
			if (contentEncoding.equals("gzip") ||
					contentEncoding.equals("deflate")) {
				bcontent = decodeGzip(bcontent, contentEncoding);
			} else if (!contentEncoding.equals("identity")) {
				Logger.info("Unknown compress format. save comment failed.");
				return null;
			}
		}
		return bcontent;
	}

/*
 * obt@t@CɕۑALbVXgɓo^
 */
	private boolean saveCommentFile(
			byte[] buf, String id, String date, String flag)
				throws IOException {
// t@Cl[
		String fileName = cacheCommentDir+"/"+id+"_"+date+flag+".xml";

		File file = new File(fileName);
		BufferedOutputStream bos =
				new BufferedOutputStream(new FileOutputStream(file));
		try {
			bos.write(buf);
			bos.flush();
		} catch (IOException e) {
			Logger.info("comment save error.");
			return false;
		} finally {
			CloseUtil.close(bos);
		}

// Xgɓo^
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap == null) {
			nameMap = new ConcurrentHashMap<String, File>();
		}
		nameMap.put(date+flag, file);
		id2NameMap.put(id, nameMap);

		return true;
	}

/*
 * ID̃RgLbV݂Ătrue
 */
	private boolean existComment(String id) {
		if (id == null) {
			return false;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
// idL[ɂĂA폜ĒgȂ邩
		if (nameMap == null) {
			return false;
		}
		if (nameMap.size() == 0) {
			return false;
		}
		return true;
}

/*
 * IDADATẼRgLbV݂Ătrue
 */
	private boolean existComment(String id, String date) {
		if (id == null) {
			return false;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
// idL[ɂĂA폜ĒgȂ邩
		if (nameMap == null) {
			return false;
		}
		if (nameMap.get(date+NORMAL_COMMENT) == null) {
			return false;
		}
		return true;
}

/*
 * k𓀂
 */
	private static final int GZIP_BUF_SIZE = 1024*10;
	private byte[] decodeGzip(byte[] bcontent, String format) {
		BufferedInputStream in = null;
 		ByteArrayOutputStream out = new ByteArrayOutputStream();
		int len;
		byte[] buf = new byte[GZIP_BUF_SIZE];

		try {
			if (format.equals("gzip")) {
				in = new BufferedInputStream(
						new GZIPInputStream(
							new ByteArrayInputStream(bcontent)));
			} else if (format.equals("deflate")) {
				in = new BufferedInputStream(
						new InflaterInputStream(
							new ByteArrayInputStream(bcontent)));
			}
			while ( (len = in.read(buf, 0, GZIP_BUF_SIZE)) != -1) {
				out.write(buf, 0, len);
			}
		} catch (IOException e) {
			return null;
		} finally {
			CloseUtil.close(in);
		}
		return out.toByteArray();
	}

/*
 * uEUǂݍłRgLbV
 * R͈ꎞobt@ɓāAŃyAɂ
 */
	private void storeComment(byte[] buf, String watchId, String postString)
				throws IOException {
		String id = null;
		String content = new String(buf, "utf-8");
		Pattern pattern = Pattern.compile(" id=\"([a-z]{2}[0-9]+)\"");
		Matcher m = pattern.matcher(content);
		if (m.find()) {
			id = m.group(1);
		}

// watchy[WID}C[ǂ
// nullłȂ΃}C[ɂȂ
		pattern = Pattern.compile("[0-9]+t([0-9]+)");
		m = pattern.matcher(watchId);
		String pageId = null;
		if (m.find()) {
			pageId = m.group(1);
		}
// RȂꎞobt@ɕۑ
		if (id == null) {
			tmp_watchId2Buf.put(watchId, buf);
			return;
		}
// ʃR
		boolean keepComment = false;
		String configAutoCacheComment = System.getProperty("autoCacheComment", "false");
		int lastRes = 0;
		pattern = Pattern.compile(" last_res=\"([0-9]+)\" ");
		m = pattern.matcher(content);
		if (m.find()) {
			lastRes = Integer.decode(m.group(1));
		}

// }C[͕ۑɂ܂킷B
// }C[lastRes̓LbVȂ̂0ɂ
// }C[͏ɕۑ̂ŁAVRg
// ۑĂ&lastRes܂LbVĂȂƁA
// }C[lastResŐVƊႢ邩
		if (pageId != null) {
			lastRes = 0;
			keepComment = true;
// t@CȂۑ
		} else if (!existComment(id)) {
			keepComment = true;
// one[hȂ΁AVX̐𒲂ׂ
		} else if (!configAutoCacheComment.equals("one")) {
			int oldRes = 0;
			int existRes = getLastResCacheComment(id);
			int refreshThreshold = 0;

			if (configAutoCacheComment.matches("[0-9]+")) {
				refreshThreshold = Integer.decode(configAutoCacheComment);
			}
			pattern = Pattern.compile(" no=\"([0-9]+)\" ");
			m = pattern.matcher(content);
			if (m.find()) {
				oldRes = Integer.decode(m.group(1));
			}
			if (lastRes != 0 && oldRes != 0) {
				int maxRes = 0;
				int newRes = lastRes - existRes;
				pattern = Pattern.compile(">0-([0-9]+):[0-9]+,([0-9]+)</thread_leaves>");
				m = pattern.matcher(postString);
				if (m.find()) {
			//		maxRes = Integer.decode(m.group(1)) * 100 + Integer.decode(m.group(2));	// Ƃ肠A100R/Œ炵
					maxRes = Integer.decode(m.group(1)) * 100;	// ̋Rg𑫂ƑSRXVȂ㏑
				} else {
					pattern = Pattern.compile(">0-([0-9]+):[0-9]+</thread_leaves>");
					m = pattern.matcher(postString);
					if (m.find()) {
						maxRes = Integer.decode(m.group(1)) * 100;
					} else {
						pattern = Pattern.compile(" res_from=\"-([0-9]+)\" ");
						m = pattern.matcher(postString);
						if (m.find()) {
							maxRes = Integer.decode(m.group(1));
						}
					}
				}
//				Logger.info("[debug] " + id + " : maxRes = " + maxRes + " : newRes = " + newRes);
// \ȔBRgȂɂ͌딚
				if (maxRes == 0){
					maxRes = lastRes - oldRes +1;
					if (maxRes > 1000) {
						// dlύX1000Rȏ̓悪(10ȏ)
					} else if (lastRes > 500 && maxRes > 500) {
						maxRes = 1000;
					} else if (lastRes > 250 && maxRes > 250) {
						maxRes = 500;
					} else if (lastRes > 100 && maxRes > 100) {
						maxRes = 250;
					} else {
						maxRes = 100;
					}
				}
				if (maxRes * refreshThreshold / 100 < newRes) {
					keepComment = true;
				}
			}
		}

// ŕۑƔ肳Ă
		if (keepComment) {
// xmlANZX̃T[oԂ擾
			String time;
			pattern = Pattern.compile(" server_time=\"([0-9]+)\"");
			m = pattern.matcher(content);
			if (m.find()) {
				time = m.group(1);
			} else {
// Ԃ擾łȂ΃G[
				return;
			}
			String date = new SimpleDateFormat("yyMMddHHmmss").format(
					new Date(Long.decode(time+"000")));
// }C[ȂAxmlŏIRg擾
			if (pageId != null) {
// Ō̃RgŏIRgEEÊ͂
				if (content.lastIndexOf(" date=\"") == -1) {
					return;
				}
				String subStr = content.substring(content.lastIndexOf(" date=\""));
				pattern = Pattern.compile(" date=\"([0-9]+)\"");
				m = pattern.matcher(subStr);
				if (m.find()) {
					date = new SimpleDateFormat("yyMMddHHmmss").format(
							new Date(
								Long.decode(m.group(1)+"000")));
				} else {
					Logger.info("cacheCommentExtension : cannot get Date from xml. Use serverTime...");
				}
			}

// łɓtŕۑĂX[
			if (!existComment(id, date)) {
	 			if (!saveCommentFile(buf, id, date, NORMAL_COMMENT)) {
					return;
				}
// Ή铊R邩ǂ
				byte[] tmp_buf = tmp_watchId2Buf.get(watchId);
				if (tmp_buf != null) {
// Ή铊R̕ۑɎsʃR폜
					if (!saveCommentFile(tmp_buf, id, date, AUTHOR_COMMENT)) {
						removeCommentFile(id, date, NORMAL_COMMENT);
						return;
					}
				}
// lastResۑB0͕̎ۑȂ
				if (lastRes != 0)
					setLastResCacheComment(id, lastRes);
				
				pattern = Pattern.compile("</chat>");
				m = pattern.matcher(content);
				int commentLength = 0;
				while (m.find()) {
					commentLength++;
        		}
        		Logger.info("autoCacheComment : "+id + " (" + commentLength + ")");
			}
		}
// ʃȐIAΉ铊R̈ꎞLbV폜
// ŃG[cႤǁÂ邩炢
		removeTempComment(watchId);
	}

/*
 * ID̓ŕۑꂽRǵAŌ̃Rgԍݒ肷
 */
	private void setLastResCacheComment(String id, int lastRes) {
		Integer res = id2LastRes.get(id);
		if (res == null || res.intValue() < lastRes) {
			id2LastRes.put(id, lastRes);
		}
	}

/*
 * ID̓ŕۑꂽRǵAŏIRgԍ擾
 */
	private static final int LASTRES_BUF = 256;
	private int getLastResCacheComment(String id) {
		Integer res = id2LastRes.get(id);
// v[ĂȂ΁At@C擾
		if (res == null) {
			res = 0;
			TreeSet<String> dateTree = getCacheCommentDateTreeSet(id);
			String date;
			if (dateTree != null && !dateTree.isEmpty()) {
				date = dateTree.last();
				File file = id2NameMap.get(id).get(date);
				BufferedInputStream in = null;
				byte[] buf = new byte[LASTRES_BUF];
				String content = "";
// 擪ǂݍ
				try {
					int pos = 0;
					in = new BufferedInputStream(
							new FileInputStream(file));
					while (pos < LASTRES_BUF) {
						int len = in.read(buf, pos, LASTRES_BUF-pos);
						if (len == -1) break;
						pos += len;
					}
					content = new String(buf, 0, pos, "utf-8");
				} catch (IOException e) {
 				} finally {
					CloseUtil.close(in);
				}

				Pattern pattern = Pattern.compile(" last_res=\"([0-9]+)\" ");
				Matcher m = pattern.matcher(content);
				if (m.find()) {
					res = Integer.decode(m.group(1));
				} else {
		//			Logger.info("[debug] cc:LASTRES_BUF is too small");
				}
				pattern = Pattern.compile(" res_offset=\"([0-9]+)\" ");
				m = pattern.matcher(content);
				if (m.find()) {
					res += Integer.decode(m.group(1));
				}
			}
// 擾LbVցBǂݍ߂Ȃ0
			setLastResCacheComment(id, res);
		}
		return res;
	}

/*
 * IDɂRg̓tTreeSetԂB\[gĂ
 * flagĂ
 */
	private TreeSet<String> getCacheCommentDateTreeSet(String id) {
		TreeSet<String> cacheDateTreeSet = null;
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap != null) {
			cacheDateTreeSet = new TreeSet<String>(nameMap.keySet());
		}
		return cacheDateTreeSet;
	}

/*
 * w肵watchId̈ꎞLbV폜
 */
	private void removeTempComment(String watchId) {
		tmp_watchId2Buf.remove(watchId);
// ؂̓RꎞLbV폜
// Ƃ肠120bɂĂ݂
		Pattern pattern = Pattern.compile("^[0-9]+t([0-9]+)$");
		Matcher m;
		for (String idTemp : tmp_watchId2Buf.keySet()) {
			m = pattern.matcher(idTemp);
			if (m.matches()) {
				long time = Long.decode(m.group(1));
				if (time < new Date().getTime() -120*1000) {
					tmp_watchId2Buf.remove(idTemp);
				}
			} else {
// Ԃ̎擾łȂȈꎞLbV͍폜
				tmp_watchId2Buf.remove(idTemp);
			}
		}
	}

/*
 * AtomicIDԂ
 */
	private String getWatchIdComment() {
		return watchIdSource.getAndIncrement()+"t";
	}

/*
 * Rgt@C̍폜
 */
// ID,ԁAʎw
	private void removeCommentFile(
				String id, String date, String flag) {
		if (id == null) {
			return;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap == null) {
			return;
		}
		File file = nameMap.get(date+flag);
		if (file != null) {
			file.delete();
		}
		nameMap.remove(date+flag);
		id2NameMap.put(id, nameMap);
	}

// IDƎԎw
	private void removeCommentFile(String id, String date) {
		if (id == null) {
			return;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap == null) {
			return;
		}
		File file = nameMap.get(date+NORMAL_COMMENT);
		if (file != null) {
			file.delete();
			nameMap.remove(date+NORMAL_COMMENT);
		}
		file = nameMap.get(date+AUTHOR_COMMENT);
		if (file != null) {
			file.delete();
			nameMap.remove(date+AUTHOR_COMMENT);
		}
		if (nameMap.isEmpty()) {
			id2NameMap.remove(id);
		} else {
			id2NameMap.put(id, nameMap);
		}
		id2LastRes.remove(id);
	}

// ID̂ݎwō폜
	private void removeCommentFile(String id) {
		if (id == null) {
			return;
		}
		ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
		if (nameMap == null) {
			return;
		}
		File file;
		for (Iterator<File> j = nameMap.values().iterator(); j.hasNext();) {
			file = j.next();
			if (file != null) {
				file.delete();
			}
		}
		id2NameMap.remove(id);
		id2LastRes.remove(id);
	}

// LbV̂ȂRg폜
	private void removeCommentExistMovie() {
		String id;
		for (Iterator<String> j = id2NameMap.keySet().iterator(); j.hasNext();) {
			id = j.next();
			if ( Cache.getType(id) == null) {
				removeCommentFile(id);
			}
		}
	}

// Rgȉ̃Rgt@C폜
	private void removeShortCommentFile(int commentNum) {
		String id;
		for (Iterator<String> i = id2NameMap.keySet().iterator(); i.hasNext();) {
			id = i.next();
			ConcurrentHashMap<String, File> nameMap = id2NameMap.get(id);
			String dates;
			for (Iterator<String> j = nameMap.keySet().iterator(); j.hasNext();) {
				dates = j.next();
				if (dates.endsWith(NORMAL_COMMENT)) {
// Rg͖ʓ|ȂōŏI擾Rԍސ
					int res = 0;
					File file = nameMap.get(dates);
					BufferedInputStream in = null;
					byte[] buf = new byte[LASTRES_BUF];
					String content = "";
// 擪ǂݍ
					try {
						int pos = 0;
						in = new BufferedInputStream(
								new FileInputStream(file));
						while (pos < LASTRES_BUF) {
							int len = in.read(buf, pos, LASTRES_BUF-pos);
							if (len == -1) break;
							pos += len;
						}
						content = new String(buf, 0, pos, "utf-8");
					} catch (IOException e) {
 					} finally {
						CloseUtil.close(in);
					}

					Pattern pattern = Pattern.compile(" last_res=\"([0-9]+)\" ");
					Matcher m = pattern.matcher(content);
					if (m.find()) {
						res += Integer.decode(m.group(1));
					}
					pattern = Pattern.compile(" res_offset=\"([0-9]+)\" ");
					m = pattern.matcher(content);
					if (m.find()) {
						res += Integer.decode(m.group(1));
					}
// Ȃ폜
					if (res < commentNum) {
						removeCommentFile(id, dates.substring(0, dates.length()-1));
					}

				}
			}
		}
	}
	
	private String addTS(String fileName){
		Matcher m = Pattern.compile("^(?:http://[^/]*\\.nicovideo\\.jp/|/)?(local/[^?]+)").matcher(fileName);
		if (m.find()) {
			// t@C݂ꍇ̂݃p[^t
			long lastModified = new File(m.group(1)).lastModified();
			if (lastModified > 0L) {
				fileName += "?" + (lastModified / 1000L);
			}
		}
		return fileName;
	}
	
	private String addTS2(String fileName){
		Matcher m = Pattern.compile("^(.*\"(?:http://[^/]*\\.nicovideo\\.jp/|/)?(local/[^?\"]+)(?:[?][^\"]*)?)(\".*$)").matcher(fileName);
		if (m.find()) {
			// t@C݂ꍇ̂݃p[^t
			long lastModified = new File(m.group(2)).lastModified();
			if (lastModified > 0L) {
				fileName = m.group(1) + "?" + (lastModified / 1000L) + m.group(3);
			}
		}
		return fileName;
	}
}
/* end */

